---
created: 2024-05-19T17:41:08-05:00
modified: 2024-05-19T17:41:12-05:00
---

# Reading list

In addition to the below list, I also heavily consulted the [RISC-V ISA specifications](https://riscv.org/technical/specifications/) which, at the time of writing, were last ratified and published on April 11, 2024.

## Guides
- [*Writing a RISC-V operating system kernel in Rust* series](https://www.meyerzinn.tech/posts/2023/03/04/rust-operating-system-intro/), Meyer Zinn, 2023
- [*The Adventures of OS*](https://osblog.stephenmarz.com/), Stephen Marz, 2019
- [*Writing an OS in Rust*](https://os.phil-opp.com/), Philipp Oppermann

## Other reading
- https://twilco.github.io/riscv-from-scratch/2019/04/27/riscv-from-scratch-2.html
- https://danielmangum.com/categories/risc-v-bytes/

## Other projects
- [skyzh/core-os-riscv](https://github.com/skyzh/core-os-riscv)
- [mit-pdos/xv6-riscv](https://github.com/mit-pdos/xv6-riscv)

## Videos
- [Sarah Jamie Lewis's "Let's Build An OS" series](https://www.youtube.com/watch?v=s_4tFz52jbc) (Note: it *can* run Doom)
- [Dr. Harry Porter's lectures on the xv6 kernel](https://www.youtube.com/watch?v=fWUJKH0RNFE&list=PLbtzT1TYeoMhTPzyTZboW_j7TPAnjv9XB)
- [LaurieWired's RISC-V Assembly primer](https://www.youtube.com/watch?v=0IeOaiKszLk)